import type { Collection, ITribute, ITributeContext, ITributeEvents, ITributeMenu, ITributeRange, ITributeSearch, TributeArgument, TributeCollection, TributeElement, TributeItem, TributeTemplate } from './type';
declare class Tribute<T extends {}> implements ITribute<T> {
    allowSpaces: boolean;
    autocompleteMode: boolean;
    autocompleteSeparator: RegExp | null;
    collection: Collection<T>[];
    iframe?: HTMLIFrameElement;
    closeOnScroll: boolean | HTMLElement;
    currentMentionTextSnapshot?: string;
    hasTrailingSpace: boolean;
    menu: ITributeMenu<T>;
    menuContainer?: Element | null;
    positionMenu: boolean;
    replaceTextSuffix: string | null;
    spaceSelectsMatch: boolean;
    _isActive: boolean;
    events: ITributeEvents;
    menuEvents: ITributeEvents;
    range: ITributeRange<T>;
    search: ITributeSearch<T>;
    current: ITributeContext<T>;
    constructor({ values, loadingItemTemplate, iframe, shadowRoot, selectClass, containerClass, itemClass, trigger, autocompleteMode, autocompleteSeparator, selectTemplate, menuItemTemplate, lookup, fillAttr, collection, menuContainer, noMatchTemplate, requireLeadingSpace, allowSpaces, replaceTextSuffix, positionMenu, spaceSelectsMatch, searchOpts, menuItemLimit, menuShowMinLength, closeOnScroll, maxDisplayItems, isBlocked, }: TributeCollection<T> & TributeTemplate<T> & TributeArgument<T>);
    get isActive(): boolean;
    set isActive(val: boolean);
    triggers(): string[];
    attach(el: TributeElement | JQuery<HTMLElement>): void;
    _attach(el: HTMLElement): void;
    ensureEditable(element: HTMLElement): void;
    showMenuFor(element: HTMLElement & {
        tributeMenu?: HTMLElement;
    }, scrollTo?: boolean): void;
    showMenuForCollection(element: HTMLElement, collectionIndex?: number): void;
    placeCaretAtEnd(el: HTMLElement): void;
    insertTextAtCursor(text: string): void;
    insertAtCaret(textarea: HTMLInputElement | HTMLTextAreaElement, text: string): void;
    hideMenu(): void;
    selectItemAtIndex(index: string, originalEvent: Event): void;
    replaceText(content: string | HTMLElement, originalEvent: Event, item: TributeItem<T>): void;
    _append(collection: TributeCollection<T>, newValues: T[], replace: boolean): void;
    append(collectionIndex: string, newValues: [], replace?: boolean): void;
    appendCurrent(newValues: T[], replace: boolean): void;
    detach(el: TributeElement): void;
    _detach(el: HTMLElement & {
        tributeMenu?: HTMLElement;
    }): void;
    static isContentEditable(element: HTMLElement): boolean;
}
export default Tribute;
