import type { Collection, ITribute, ITributeContext, TributeItem, TriggerInfo } from './type';
declare class TributeContext<T extends {
    disabled?: boolean;
}> implements ITributeContext<T> {
    element?: HTMLElement;
    filteredItems?: TributeItem<T>[];
    collection?: Collection<T>;
    mentionText: string;
    externalTrigger: boolean;
    tribute: ITribute<T>;
    selectedPath?: (number | undefined)[];
    selectedOffset?: number;
    trigger?: string;
    constructor(tribute: ITribute<T>);
    process(scrollTo: boolean): void;
    updateSelection(info: TriggerInfo): void;
    get isMentionLengthUnderMinimum(): boolean | undefined;
    _filterItems(collection: Collection<T>, values: T[]): TributeItem<T>[];
    _handleNoItem(ul: HTMLElement, collection: Collection<T>, scrollTo: boolean): void;
    _renderMenu(items: TributeItem<T>[], ul: HTMLElement, collection: Collection<T>, scrollTo: boolean): void;
    _createMenuItem(item: TributeItem<T>, collection: Collection<T>, index: number, doc: Document): HTMLLIElement;
    _findLiTarget(el: EventTarget | null): [] | [EventTarget, string | null];
}
export default TributeContext;
