import type { ITribute } from './type';
declare const hotkeys: readonly ["tab", "backspace", "enter", "escape", "space", "arrowup", "arrowdown"];
type hotkeyType = (typeof hotkeys)[number];
declare class TributeEvents<T extends {}> {
    removers: (() => void)[];
    tribute: ITribute<T>;
    inputEvent: boolean;
    commandEvent?: boolean;
    constructor(tribute: ITribute<T>);
    bind(element: EventTarget): void;
    unbind(element: EventTarget): void;
    keydown(event: Event): void;
    input(event: Event): void;
    keyup(event: Event): void;
    shouldDeactivate(event: Event): boolean;
    getTriggerCharCode(): number | false;
    updateSelection(el: HTMLElement): void;
    triggerChar(e: Event, el: HTMLElement, trigger: string): void;
    _callbacks?: {
        [key in hotkeyType]: (e: Event, el: HTMLElement) => void;
    };
    get callbacks(): {
        [key in hotkeyType]: (e: Event, el: HTMLElement) => void;
    };
    showMenuOnBackspace(key: string): boolean;
}
export default TributeEvents;
