import type { Coordinate, ITribute, ITributeContext, ITributeRange, TributeItem, TriggerInfo } from './type';
type Rect = {
    top: number;
    left: number;
    height: number;
    width: number;
};
type SelectionInfo = {
    selected: Node;
    path?: (number | undefined)[];
    offset?: number;
};
type Trigger = {
    mostRecentTriggerCharPos: number;
    triggerChar: string;
    requireLeadingSpace: boolean;
};
declare class TributeRange<T extends {}> implements ITributeRange<T> {
    tribute: ITribute<T>;
    constructor(tribute: ITribute<T>);
    getDocument(): Document;
    positionMenuAtCaret(scrollTo: boolean): void;
    get menuContainerIsBody(): boolean;
    replaceTriggerText(text: string | HTMLElement, requireLeadingSpace: boolean, hasTrailingSpace: boolean, originalEvent: Event, item: TributeItem<T>): void;
    pasteHtml(htmlOrElem: string | HTMLElement, startPos: number, endPos: number): void;
    getWindowSelection(): Selection | null;
    getNodePositionInParent(element: Node): number | undefined;
    getContentEditableSelectedPath(context: ITributeContext<T>): SelectionInfo | undefined;
    getTextPrecedingCurrentSelection(): string | undefined;
    getLastWordInText(text: string): string | undefined;
    getTriggerInfo(menuAlreadyActive: boolean, hasTrailingSpace: boolean, requireLeadingSpace: boolean, allowSpaces: boolean, isAutocomplete: boolean): TriggerInfo | undefined;
    _getSelectionInfo(context: ITributeContext<T>): SelectionInfo | undefined;
    _getTriggerInfoWithAutocomplete(selectionInfo: SelectionInfo, effectiveRange: string): {
        mentionPosition: number;
        mentionText: string | undefined;
        mentionSelectedElement: Node;
        mentionSelectedPath: (number | undefined)[] | undefined;
        mentionSelectedOffset: number | undefined;
    };
    _getTrigger(requireLeadingSpace: boolean, effectiveRange: string): Trigger | undefined;
    _getTriggerInfoNonAutocomplete(menuAlreadyActive: boolean, hasTrailingSpace: boolean, allowSpaces: boolean, effectiveRange: string, trigger: Trigger, selectionInfo?: SelectionInfo): {
        mentionPosition: number;
        mentionText: string;
        mentionSelectedElement: Node | undefined;
        mentionSelectedPath: (number | undefined)[] | undefined;
        mentionSelectedOffset: number | undefined;
        mentionTriggerChar: string;
    } | undefined;
    lastIndexWithLeadingSpace(str: string, trigger: string): number;
    isMenuOffScreen(coordinates: Coordinate, menuDimensions: {
        width: number;
        height: number;
    }): {
        top: boolean | undefined;
        right: boolean | undefined;
        bottom: boolean | undefined;
        left: boolean | undefined;
    };
    getTextAreaOrInputUnderlinePosition(element: HTMLInputElement | HTMLTextAreaElement, position: number, flipped?: unknown): Coordinate | undefined;
    getContentEditableCaretPosition(selectedNodePosition: number): Coordinate | undefined;
    getFixedCoordinatesRelativeToRect(rect: Rect): Coordinate;
    menu?: Node;
    scrollIntoView(elem?: unknown): void;
}
export default TributeRange;
