import type { ITribute, ITributeSearch, TributeItem, TributeSearchOpts } from './type';
declare class TributeSearch<T extends {}> implements ITributeSearch<T> {
    tribute: ITribute<T>;
    constructor(tribute: ITribute<T>);
    simpleFilter(pattern: string, array: string[]): string[];
    test(pattern: string, string: string): boolean;
    match(pattern: string, string: string, opts?: TributeSearchOpts<T>): {
        rendered: string;
        score: number;
    } | null;
    traverse(string: string, pattern: string, stringIndex: number, patternIndex: number, patternCache: number[]): {
        score: number;
        cache: number[];
    } | undefined;
    calculateScore(patternCache: number[]): number;
    render(string: string, indices: number[], pre: string, post: string): string;
    filter(pattern: string, arr: T[], opts?: TributeSearchOpts<T>): TributeItem<T>[];
}
export default TributeSearch;
